---
include:
  - remote: 'https://gitlab.com/op_so/projects/gitlab-ci-templates/-/raw/main/templates/lint.gitlab-ci.yml'

variables:
  IMAGE_PYTHON: jfxs/rye:latest
  IMAGE_WRANGLER: jfxs/wrangler:latest
  LINT_VALE: "true"
  CLOUDFLARE_PROJECT: task-templates

stages:
  - lint
  - generate
  - publish

mkdocs-build:
  image: $IMAGE_PYTHON
  stage: generate
  before_script:
    - rye sync
    - task 00:10-download-templates
    - task 00:20-generate-doc
  script:
    - rye run mkdocs build --site-dir public
  artifacts:
    paths:
      - public

cloudflare-publish:
  image: $IMAGE_WRANGLER
  stage: publish
  variables:
    WRANGLER_SEND_METRICS: "false"
  script:
    - if [ -z "$CLOUDFLARE_ACCOUNT_ID"]; then echo "CLOUDFLARE_ACCOUNT_ID is empty!" && exit 1; fi
    - if [ -z "$CLOUDFLARE_API_TOKEN"]; then echo "CLOUDFLARE_API_TOKEN is empty!" && exit 1; fi
    - npx wrangler pages deploy public --branch=main --project-name $CLOUDFLARE_PROJECT
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
